searchNodes=[{"ref":"GeoIP.html","title":"GeoIP","type":"module","doc":"Elixir library to lookup the geo location for an IP address or hostname using freegeoip.net iex&gt; GeoIP.lookup(&quot;google.com&quot;) {:ok, %{ city: &quot;San Francisco&quot;, country_code: &quot;US&quot;, country_name: &quot;United States&quot;, ip: &quot;192.30.253.113&quot;, latitude: 37.7697, longitude: -122.3933, metro_code: 807, region_code: &quot;CA&quot;, region_name: &quot;California&quot;, time_zone: &quot;America/Los_Angeles&quot;, zip_code: &quot;94107&quot; } }"},{"ref":"GeoIP.html#lookup/1","title":"GeoIP.lookup/1","type":"function","doc":"Lookup the location for the given IP address/hostname. Args: host - The IP/hostname or Plug.Conn instance to use for the lookup. The IP can be either a string or a tuple. This function returns {:ok, response} if the lookup is successful, {:error, %GeoIP.Error{reason: reason}} otherwise. Examples: {:ok, location} = GeoIP.lookup({8, 8, 8, 8}) {:ok, location} = GeoIP.lookup(&quot;8.8.8.8&quot;) {:ok, location} = GeoIP.lookup(&quot;google.com&quot;) {:ok, location} = GeoIP.lookup(conn) # A `Plug.Conn` instance"},{"ref":"GeoIP.html#start/2","title":"GeoIP.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"GeoIP.Config.html","title":"GeoIP.Config","type":"module","doc":""},{"ref":"GeoIP.Config.html#api_key/0","title":"GeoIP.Config.api_key/0","type":"function","doc":""},{"ref":"GeoIP.Config.html#api_key!/0","title":"GeoIP.Config.api_key!/0","type":"function","doc":""},{"ref":"GeoIP.Config.html#cache_enabled?/0","title":"GeoIP.Config.cache_enabled?/0","type":"function","doc":""},{"ref":"GeoIP.Config.html#cache_ttl_secs/0","title":"GeoIP.Config.cache_ttl_secs/0","type":"function","doc":""},{"ref":"GeoIP.Config.html#default_test_result/0","title":"GeoIP.Config.default_test_result/0","type":"function","doc":""},{"ref":"GeoIP.Config.html#extra_params/0","title":"GeoIP.Config.extra_params/0","type":"function","doc":""},{"ref":"GeoIP.Config.html#provider!/0","title":"GeoIP.Config.provider!/0","type":"function","doc":""},{"ref":"GeoIP.Config.html#test_results/0","title":"GeoIP.Config.test_results/0","type":"function","doc":""},{"ref":"GeoIP.Config.html#url!/0","title":"GeoIP.Config.url!/0","type":"function","doc":""},{"ref":"GeoIP.Config.html#use_https/0","title":"GeoIP.Config.use_https/0","type":"function","doc":""},{"ref":"GeoIP.Error.html","title":"GeoIP.Error","type":"exception","doc":""},{"ref":"GeoIP.Error.html#message/1","title":"GeoIP.Error.message/1","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"GeoIP.Error.html#t:t/0","title":"GeoIP.Error.t/0","type":"type","doc":""},{"ref":"GeoIP.Lookup.html","title":"GeoIP.Lookup","type":"module","doc":""},{"ref":"GeoIP.Lookup.html#lookup/1","title":"GeoIP.Lookup.lookup/1","type":"function","doc":""},{"ref":"readme.html","title":"GeoIP","type":"extras","doc":"GeoIP Elixir library to lookup the geographic location for a given IP address, hostname, or Plug.Conn. The returned results are cached for an hour by default so that we don&#39;t hit the service unnecessarily, but this is configurable can be disabled using the config options (see below)."},{"ref":"readme.html#installation","title":"GeoIP - Installation","type":"extras","doc":"Add geoip to your list of dependencies in mix.exs: def deps do [{:geoip, &quot;~&gt; 0.2&quot;}] end Update your mix dependencies mix deps.get Add geoip to your applications list if you&#39;re using Elixir version 1.3 or lower def application do [applications: [:geoip]] end"},{"ref":"readme.html#configuration","title":"GeoIP - Configuration","type":"extras","doc":"Provider The provider must be explicitly specified along with any required attributes as per examples below. freegeoip The free host that was available at freegeoip.net and the corresponding source repository at fiorix/freegeoip was deprecated in the middle of 2018, but it still allows you to launch your own instance if you wish. config :geoip, provider: :freegeoip, url: &quot;https://geoip.example.com&quot; ipstack ipstack provides a free tier although it requires you to sign up and get an api key first. NOTE: The free tier does not allow https access so you must specify use_https: false below. config :geoip, provider: :ipstack, api_key: &quot;your-api-key&quot; ipinfo ipinfo does not unfortunately support lookup by hostname (only ip address), therefore the above examples where a hostname is used will return an error. config :geoip, provider: :ipinfo, api_key: &quot;your-api-key&quot; test Provides an easy way to provide mock lookup data in test environments. The test_results param is a map of host to lookup results that should be returned. If the ip/host looked up is not found in this map, then the results provided by the default_test_result param is provided. config :geoip, provider: :test, test_results: %{ # optional &quot;host.1&quot; =&gt; %{ ip: &quot;123.123.123.123&quot;, # ...... }, &quot;host.2&quot; =&gt; %{ ip: &quot;1.1.1.1&quot;, # ...... }, }, default_test_result: %{ # optional ip: &quot;192.168.3.3&quot;, # ...... } Caching By default, the location results returned by the freegeoip server is cached for an hour. We can disable the cache by: config :geoip, cache: false Or to change the time limit of cached results: config :geoip, cache_ttl_secs: 1800 # 30 mins Extra parameters You can add extra query parameters to geoip service requests via :extra_params config option: config :geoip, extra_params: [language: &quot;RU&quot;]"},{"ref":"readme.html#usage","title":"GeoIP - Usage","type":"extras","doc":"You can pass in an IP address (as a string or a struct), hostname or a Plug.Conn struct to be looked up. GeoIP.lookup(&quot;google.com&quot;) #=&gt; {:ok, %{city: &quot;Mountain View&quot;, country_code: &quot;US&quot;, country_name: &quot;United States&quot;, ip: &quot;172.217.4.78&quot;, latitude: 37.4192, longitude: -122.0574, metro_code: 807, region_code: &quot;CA&quot;, region_name: &quot;California&quot;, time_zone: &quot;America/Los_Angeles&quot;, zip_code: &quot;94043&quot;}} # Other examples: GeoIP.lookup(&quot;8.8.8.8&quot;) GeoIP.lookup({8, 8, 8, 8}) GeoIP.lookup(conn) This returns {:ok, response} if the lookup is successful, {:error, %GeoIP.Error{reason: reason}} otherwise."},{"ref":"readme.html#testing","title":"GeoIP - Testing","type":"extras","doc":"Please see the test provider above."},{"ref":"readme.html#determining-your-remote_ip-when-behind-a-proxy","title":"GeoIP - Determining your remote_ip when behind a proxy","type":"extras","doc":"If your application is running behind a proxy, we recommend using ajvondrak/remote_ip or something similar to override the remote_ip field of Plug.Conn. Due to the various different ways of determining the applications remote ip depending on your deployment environment, we leave this up to you to configure as appropriate."},{"ref":"readme.html#geoip-logo","title":"GeoIP - GeoIP logo","type":"extras","doc":"Special thanks to @batarian71 for designing and providing this project with an awesome logo"},{"ref":"readme.html#license","title":"GeoIP - License","type":"extras","doc":"The MIT License Copyright (c) 2016-present Navin Peiris Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE."}]